//Minified w/ JSMin: see https://github.com/1ec5/avim/blob/v5.3.1/content/frame.js
"use strict";(function(msgMgr){const Cc=Components.classes;const Ci=Components.interfaces;const Cu=Components.utils;const iCloudHostname="www.icloud.com";const GDocsHostname="docs.google.com";const ZohoHostname="docs.zoho.com";const isChrome=typeof(window)==="object";let AVIMConfig;if(isChrome)AVIMConfig=avim.onFrameReadyForPrefs();else{let results=sendSyncMessage("AVIM:readyforprefs");if(results)AVIMConfig=results[0];addMessageListener("AVIM:prefschanged",function(msg){ AVIMConfig=msg.data;});}
const wordChars="\u0400-\u052f\u2de0-\u2dff\ua640-\ua69f"+"\u0370-\u03ff\u1f00-\u1fff"+"A-Za-zÀ-ÖØ-öø-\u02af\u1d00-\u1dbf\u1e00-\u1eff\u2c60-\u2c7f"+"\ua720-\ua7ff\uab30-\uab6f\ufb00-\ufb4f"+"\u0600-\u06ff\u0750-\u077f\u08a0-\u08ff\ufb50-\ufdff\ufe70-\ufeff"+"\u0590-\u05ff\ufb1d-\ufb40"+"\u0900-\u097f\u1cd0-\u1cff"+"\u02b0-\u02ff"+"0-9"+"₫\u0303"+"’";const wordRe=new RegExp("["+wordChars+"]*$");function quoteJS(str){return"\""+str.replace(/\\/g,"\\\\").replace(/[\b]/g,"\\b").replace(/\f/g,"\\f").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/\t/g,"\\t").replace(/\v/g,"\\v").replace(/"/g,"\\\"")+"\"";}
function methodIsVIQR(){if(AVIMConfig.method>2)return true;return AVIMConfig.method==0&&(AVIMConfig.autoMethods.viqr||AVIMConfig.autoMethods.viqrStar);}
function lastWordInString(str){if(!str)return"";if(str.substr(-1)==="\\"&&methodIsVIQR())return"\\";let match=wordRe.exec(str);return match&&match[0];}
const subscriptLoader=Cc["@mozilla.org/moz/jssubscript-loader;1"].getService(Ci.mozIJSSubScriptLoader);function loadSubScript(uri,target){if("loadSubScriptWithOptions"in subscriptLoader){let options={charset:"UTF-8",};if(target)options.target=target;subscriptLoader.loadSubScriptWithOptions(uri,options);}
else subscriptLoader.loadSubScript(uri,target,"UTF-8");}
function Sandbox(principal){let sandbox=new Cu.Sandbox(principal,{sandboxName:"avim",sandboxPrototype:principal,wantXrays:false,});if(!sandbox)throw"No sandbox to evaluate in.";const jsVersion="1.7";const evalInBox=Cu.evalInSandbox;this.evalBoolean=function(text){return evalInBox("!!("+text+")",sandbox,jsVersion);};

this.createObjectAlias=function(name,text){sandbox[name]=evalInBox("("+text+")||undefined",sandbox,jsVersion);return sandbox[name]!==undefined;};this.importFunction=function(fn,name){sandbox.importFunction(fn,name);};this.injectScript=function(uri){loadSubScript(uri,sandbox);};this.nuke=function(){if("nukeSandbox"in Cu)Cu.nukeSandbox(sandbox);sandbox=null;};}
function getEditor(el){if(!el)return undefined;try{return el.QueryInterface(Ci.nsIDOMNSEditableElement).editor;}
catch(e){}
try{return el.QueryInterface(Ci.nsIEditor).editor;}
catch(e){}
try{ let webNavigation=el.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation);let editingSession=webNavigation.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIEditingSession);return editingSession.getEditorForWindow(el);}
catch(e){} 
return undefined;}
function SpliceTxn(outer,node,pos,len,repl){ this.isTransient=false;let editor=getEditor(outer);let sel=editor&&editor.selection;this.startOffset=sel&&sel.anchorOffset;this.shiftSelection=function(numChars){let editor=getEditor(outer);let sel=editor&&editor.selection;sel.collapse(node,this.startOffset+numChars);};this.doTransaction=this.redoTransaction=function(){this.orig=node.substringData(pos,len);node.deleteData(pos,len);node.insertData(pos,repl);this.shiftSelection(repl.length-len);};this.undoTransaction=function(){node.deleteData(pos,repl.length);node.insertData(pos,this.orig);this.shiftSelection(0);};this.merge=function(aTransaction){return false;};this.QueryInterface=function(iid){if(iid==Ci.nsITransaction||iid==Ci.nsISupports)return this;return null;};}
function applyKey(word,evt){let data={prefix:word,evt:{keyCode:evt.keyCode,which:evt.which,shiftKey:evt.shiftKey,},};if(isChrome)return avim.onFrameKeyPress({data:data});let results=sendSyncMessage("AVIM:keypress",data);return results&&results[0];}
function splice(outer,evt){let result={};let editor=getEditor(outer);let sel=editor&&editor.selection;if(!sel||sel.rangeCount!=1||!sel.isCollapsed)return result;let node=sel.anchorNode;
if(node==editor.rootElement&&sel.anchorOffset){node=node.childNodes[sel.anchorOffset-1];if(node.data)sel.collapse(node,node.data.length);}
if(!sel.anchorOffset||!node.data)return result;let word=lastWordInString(node.substringData(0,sel.anchorOffset));result=word&&applyKey(word,evt); if(!result)return result;if(editor.beginTransaction)editor.beginTransaction();try{if("value"in result&&result.value!=word){let txn=new SpliceTxn(outer,node,sel.anchorOffset-word.length,word.length,result.value);editor.doTransaction(txn);}}
finally{
if(editor.endTransaction)editor.endTransaction();}

return result;}
function updateContainer(outer,inner){if(!inner)return;if(inner.ownerDocument&&(inner.ownerDocument.location.hostname===iCloudHostname||inner.ownerDocument.location.hostname===GDocsHostname)){return;}
let inputEvent=inner.ownerDocument.createEvent("Events");inputEvent.initEvent("input",true,true);if(inner.dispatchEvent)inner.dispatchEvent(inputEvent); if(outer&&outer.form){let controller=Cc["@mozilla.org/autocomplete/controller;1"].getService(Ci.nsIAutoCompleteController);controller.handleEndComposition();}}
function findIgnore(el){if(!el||!el.getAttribute)return true;let id=el.id||el.getAttribute("id");if(id&&id.toLowerCase&&AVIMConfig.exclude.indexOf(id.toLowerCase())>=0){return true;}
let name=el.name||el.getAttribute("name");if(name&&name.toLowerCase&&AVIMConfig.exclude.indexOf(name.toLowerCase())>=0){return true;}
let win=el.ownerDocument&&el.ownerDocument.defaultView;if(!win||!win.getComputedStyle)return false;let mode=win.getComputedStyle(el,null).getPropertyValue("ime-mode");return mode=="disabled";}
function scrollToCaret(outer){let editor=getEditor(outer);let selCtrlr=editor&&editor.selectionController;if(!selCtrlr)return;selCtrlr.scrollSelectionIntoView(selCtrlr.SELECTION_NORMAL,selCtrlr.SELECTION_FOCUS_REGION,0);}
function ifMoz(evt){let elt=evt.originalTarget;let win=new XPCNativeWrapper(elt.ownerDocument.defaultView);if(findIgnore(elt))return false;if(win.frameElement&&findIgnore(win.frameElement))return false;let result=splice(win,evt);if(result.changed){evt.stopPropagation();evt.preventDefault();updateContainer(null,elt.ownerDocument.documentElement);scrollToCaret(win);}
return!result.changed;}
function handleKeyPress(evt){


const htmlTypes=["search","text","textarea"];let elt=evt.originalTarget; if(findIgnore(evt.target)||!elt.type)return false;let isHTML=htmlTypes.indexOf(elt.type)>=0||(elt.type=="password"&&AVIMConfig.passwords)||(elt.type=="url"&&(AVIMConfig.exclude.indexOf("url")<0||AVIMConfig.exclude.indexOf("urlbar")<0))||(elt.type=="email"&&(AVIMConfig.exclude.indexOf("email")<0||AVIMConfig.exclude.indexOf("e-mail")<0));if(!isHTML||elt.selectionStart!=elt.selectionEnd)return false;let result=splice(elt,evt);if(result.changed){evt.preventDefault();updateContainer(elt,elt);scrollToCaret(elt);}
return!result.changed;}
let lazyHandlers={};function handleLazily(evt,methodName,scriptName){if(!(methodName in lazyHandlers)){loadSubScript("chrome://avim/content/"+scriptName+".js",{applyKey:applyKey,lastWordInString:lastWordInString,lazyHandlers:lazyHandlers,});}
return lazyHandlers[methodName](evt);}
function handleSciMoz(evt){return!findIgnore(evt.target)&&handleLazily(evt,"sciMoz","sciMoz");}
function handleKix(evt){return handleLazily(evt,"kix","kix");}
function keyEventString(evt){return[evt.keyCode,evt.which,evt.shiftKey].join(",");}
function safeApplyKey(word,evtProxy){let result=applyKey(word,evtProxy);return JSON.stringify([result.value,result.changed]);}
function handleWithContentScript(elt,evt,scriptName){let sandbox=new Sandbox(elt.ownerDocument.defaultView);sandbox.createObjectAlias("_avim_evtInfo","["+keyEventString(evt)+"]");sandbox.createObjectAlias("_avim_textChanged","false");sandbox.importFunction(lastWordInString,"_avim_lastWordInString");sandbox.importFunction(safeApplyKey,"_avim_applyKey");sandbox.injectScript("chrome://avim/content/editors/"+scriptName+".js");let changed=sandbox.evalBoolean("_avim_textChanged");sandbox.nuke();if(changed){evt.handled=true;evt.stopPropagation();evt.preventDefault();}
return changed;}
function handleAce(evt){ let elt=evt.originalTarget.parentNode;if(!("classList"in elt&&elt.classList.contains("ace_editor")&&elt.classList.contains("ace_focus"))||!("querySelector"in elt.ownerDocument)){return false;}
if(findIgnore(evt.target))return false; if(handleWithContentScript(elt,evt,"ace"))updateContainer(elt,elt);return true;}
function handleYmacs(evt){let elt=evt.originalTarget;let doc=elt.ownerDocument;let frameContents=doc.getElementsByClassName("Ymacs-frame-content");if(!frameContents.length)return false; if(handleWithContentScript(elt,evt,"ymacs"))updateContainer(elt,elt);return true;}
function handleCacTrang(evt){ handleWithContentScript(evt.originalTarget,evt,"trang");return true;}
function handleZD(evt){let elt=evt.originalTarget;let doc=elt.ownerDocument;let scriptName;if(doc.getElementsByClassName("zw-page").length)scriptName="zwrite";else if(doc.getElementsByClassName("slide-parent-overlay").length){scriptName="zshow";}
else return false;handleWithContentScript(evt.originalTarget,evt,scriptName);return true;} 
function slightFindIgnore(name){return name.toLowerCase&&AVIMConfig.exclude.indexOf(name.toLowerCase())>=0;}
function registerSlight(plugin){plugin.setAttribute("data-avim-registering","true");try{let sandbox=new Sandbox(plugin.ownerDocument.defaultView);sandbox.importFunction(slightFindIgnore,"_avim_findIgnore");sandbox.importFunction(lastWordInString,"_avim_lastWordInString");sandbox.importFunction(safeApplyKey,"_avim_applyKey");sandbox.injectScript("chrome://avim/content/editors/slight.js");sandbox.nuke();}
catch(exc){}
plugin.removeAttribute("data-avim-registering");}
function registerSlights(){const slightMimeTypes=["application/x-silverlight-1","application/x-silverlight-2","application/ag-plugin"];
addEventListener("PluginInstantiated",function(evt){let plugin=evt.originalTarget;if("querySelectorAll"in plugin.ownerDocument&&plugin instanceof Ci.nsIObjectLoadingContent&&slightMimeTypes.indexOf(plugin.actualType)>=0){registerSlight(plugin);}},true);}
function disableOthers(doc){if(!AVIMConfig.onOff||!AVIMConfig.disabledScripts.enabled)return;if(doc.location.protocol=="chrome:")return;
let winWrapper=new XPCNativeWrapper(doc.defaultView);let win=winWrapper.wrappedJSObject;if(win===undefined||win===null||(isChrome&&win===window)){return;} 
let sandbox=new Sandbox(doc.defaultView);let disabledScriptNames=[AVIMConfig.disabledScripts[name]&&name
for(name in AVIMConfig.disabledScripts)];sandbox.createObjectAlias("disabledScripts",quoteJS(disabledScriptNames.join("|")));sandbox.injectScript("chrome://avim/content/disabler.js");sandbox.nuke();}
function checkCode(evt){let code=evt.which;return!AVIMConfig.onOff||(code<evt.DOM_VK_INSERT&&code!=evt.DOM_VK_BACK_SPACE&&code!=evt.DOM_VK_PRINT&&code!=evt.DOM_VK_RIGHT&&code!=evt.DOM_VK_DOWN&&code!=evt.DOM_VK_EXECUTE)||code==evt.DOM_VK_SCROLL_LOCK;}
addEventListener("keydown",function(evt){ if(evt.ctrlKey||evt.metaKey||evt.altKey||checkCode(evt))return;let doc=evt.target.ownerDocument;if(isChrome&&doc.defaultView==window){doc=evt.originalTarget.ownerDocument;}
disableOthers(doc);},true);addEventListener("keypress",function(evt){ if(evt.ctrlKey||evt.metaKey||evt.altKey||checkCode(evt))return;let target=evt.target;let origTarget=evt.originalTarget;if(isChrome&&origTarget.localName==="browser")return;let doc=target.ownerDocument;if(isChrome&&doc.defaultView==window){doc=origTarget.ownerDocument;} 
let koManager=isChrome&&window.ko&&ko.views&&ko.views.manager;let koView=koManager&&koManager.currentView;let scintilla=koView&&koView.scintilla;if(scintilla&&scintilla.inputField&&origTarget==scintilla.inputField.inputField){handleSciMoz(evt);return;} 
let tagName=origTarget.localName.toLowerCase();try{ if(doc.location.hostname===iCloudHostname&&origTarget.isContentEditable){handleCacTrang(evt);return;} 
if(doc.defaultView.frameElement&&doc.defaultView.parent&&doc.defaultView.parent.location.hostname===GDocsHostname&&origTarget.isContentEditable){handleKix(evt);return;} 
if(doc.location.hostname===ZohoHostname&&origTarget.isContentEditable){handleZD(evt);return;} 
if((tagName=="html"||tagName=="body")&&handleYmacs(evt)){return;} 
if(tagName=="textarea"&&handleAce(evt))return;}
catch(exc){} 
let wysiwyg=(doc.designMode&&doc.designMode.toLowerCase()=="on")||(target.contentEditable&&target.contentEditable.toLowerCase()=="true");if(wysiwyg)ifMoz(evt); else handleKeyPress(evt);},true);registerSlights();})(this);