//Minified w/ JSMin: see https://github.com/1ec5/avim/blob/v5.3.1/content/sciMoz.js
"use strict";(function(context){function getCursorPosition(scintilla,selId,lineNum){if((selId||0)>=scintilla.selections)return-1; if(lineNum!=undefined){let caretPos=scintilla.getSelectionNCaret(0);let colNum=scintilla.getColumn(caretPos);let anchorPos=scintilla.getSelectionNAnchor(0);if(colNum!=scintilla.getColumn(anchorPos))return-1;let linePos=scintilla.positionFromLine(lineNum);caretPos=scintilla.findColumn(lineNum,colNum);return scintilla.charPosAtPosition(caretPos)-
scintilla.charPosAtPosition(linePos);}
let caretPos=scintilla.getSelectionNCaret(selId||0);if(caretPos!=scintilla.getSelectionNAnchor(selId||0))return-1;lineNum=scintilla.lineFromPosition(caretPos);let linePos=scintilla.positionFromLine(lineNum);return scintilla.charPosAtPosition(caretPos)-
scintilla.charPosAtPosition(linePos);}
function getLine(scintilla,selId,lineNum){if((selId||0)>=scintilla.selections)return-1; if(lineNum==undefined){let caretPos=scintilla.getSelectionNCaret(selId||0);lineNum=scintilla.lineFromPosition(caretPos);}
let startPos=scintilla.positionFromLine(lineNum);let endPos=scintilla.getLineEndPosition(lineNum);return scintilla.getTextRange(startPos,endPos);}
function SciMozProxy(elt,selId,lineNum){if((selId||0)>=elt.selections)return;this.elt=elt;

let selectionIsRectangle=elt.selectionMode==elt.SC_SEL_RECTANGLE||elt.selectionMode==elt.SC_SEL_THIN;if(selectionIsRectangle){this.oldSelectionStart={line:elt.lineFromPosition(elt.rectangularSelectionAnchor),col:elt.getColumn(elt.getSelectionNAnchor(0))};this.oldSelectionEnd={line:elt.lineFromPosition(elt.rectangularSelectionCaret),col:elt.getColumn(elt.getSelectionNCaret(0))};}
else{this.oldSelectionStart=elt.getSelectionNAnchor(selId);this.oldSelectionEnd=elt.getSelectionNCaret(selId);}
this.selectionStart=getCursorPosition(elt,selId,lineNum);this.selectionEnd=this.selectionStart; if(this.selectionStart<0)return;this.oldLine=getLine(elt,selId,lineNum)
let word=context.lastWordInString(this.oldLine.substr(0,this.selectionStart));this.value=word; 
this.reselectRectangle=function(colChange){elt.clearSelections();colChange=colChange||0;let anchor=elt.findColumn(this.oldSelectionStart.line,this.oldSelectionStart.col+colChange);let caret=elt.findColumn(this.oldSelectionEnd.line,this.oldSelectionEnd.col+colChange);elt.rectangularSelectionAnchor=anchor;elt.rectangularSelectionCaret=caret;};this.commit=function(){if(this.value==word)return false;if(!selectionIsRectangle){lineNum=elt.lineFromPosition(elt.getSelectionNStart(selId));}
let linePos=elt.positionFromLine(lineNum); if(selectionIsRectangle)elt.clearSelections();let startPos=elt.positionAtChar(linePos,this.selectionStart-word.length);elt.setSelectionNStart(selId,startPos);let endPos=elt.positionAtChar(linePos,this.selectionStart);elt.setSelectionNEnd(selId,endPos);


elt.replaceSel(this.value);if(selectionIsRectangle){let colChange=0;if(lineNum==Math.max(this.oldSelectionStart.line,this.oldSelectionEnd.line)){colChange=this.value.length-word.length;}
this.reselectRectangle(colChange);}
else{let colChange=this.value.length-word.length;let caretPos=elt.positionAtChar(linePos,this.selectionStart+
colChange);elt.setSelectionNStart(selId,caretPos);elt.setSelectionNEnd(selId,caretPos);}
return true;};}
context.lazyHandlers.sciMoz=function(evt){let win=evt.originalTarget.ownerDocument.defaultView;let elt=win.ko.views.manager.currentView.scimoz||evt.originalTarget;



let anyChanged=false;try{elt.beginUndoAction();let firstSel=0;let numSel=elt.selections;
let selectionIsRectangle=elt.selectionMode==elt.SC_SEL_RECTANGLE||elt.selectionMode==elt.SC_SEL_THIN;if(selectionIsRectangle){let startLine=elt.lineFromPosition(elt.rectangularSelectionAnchor);let endLine=elt.lineFromPosition(elt.rectangularSelectionCaret);firstSel=Math.min(startLine,endLine);numSel=Math.abs(endLine-startLine)+1;}
let proxy;for(let i=firstSel;i<firstSel+numSel;i++){if(selectionIsRectangle)proxy=new SciMozProxy(elt,0,i);else proxy=new SciMozProxy(elt,i);if(!proxy)continue;let result=proxy.value&&context.applyKey(proxy.value,evt);if(result){if(result.value)proxy.value=result.value;if(result.changed)anyChanged=true;}
if(proxy.commit)proxy.commit();proxy=null;}}
catch(exc){}
finally{elt.endUndoAction();}
if(anyChanged){evt.handled=true;evt.stopPropagation();updateContainer(elt,elt);return false;}
return true;};})(this);